/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2006 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

#ifndef _TINET_SYS_CONFIG_H_
#define _TINET_SYS_CONFIG_H_

/*
 *  ǡ (ͥåȥ󥿥ե) ˴ؤ
 */

/*
 *  NIC (NE2000 ߴ) ˴ؤ
 */

/* : 16 ӥåȥ⡼ɤ̤ */
#ifdef IF_ED_CFG_16BIT

#define NUM_IF_ED_TXBUF		2	/* Хåե			*/

#else	/* of #ifdef IF_ED_CFG_16BIT */

#define NUM_IF_ED_TXBUF		1	/* Хåե			*/

#endif	/* of #ifdef IF_ED_CFG_16BIT */

#define TMO_IF_ED_GET_NET_BUF	1	/* [ms] net_buf ॢ	*/
					/* [s] ॢ			*/
#define TMO_IF_ED_XMIT		(2*IF_TIMER_HZ)

/*#define IF_ED_CFG_ACCEPT_ALL		 ޥ㥹ȡ顼ե졼ȤϥȤ򳰤*/

/*
 *  NIC (RTL8019AS) ˴ؤ
 */

#define ED_BASE_ADDRESS		0x00200000		/* NIC Υ쥸١ɥ쥹 */

#define INHNO_IF_ED		IRQ_EXT5		/* IRQ5 */
#define ED_IER			H8IER
#define ED_IER_IP_BIT		H8IER_IRQ5E_BIT
#define ED_IPR			H8IPRA
#define ED_IPR_IP_BIT		H8IPR_IRQ5_BIT

/*
 *  JSP-1.4.2 ʹߤǤϡߥϥɥϿˡѹ졢
 *  ߥץ饤ƥ٥ꤹɬפ롣
 */

#define ED_IPM			IPM_LEVEL1

/*  
 * ߥϥɥ¹γߥޥ
 * ¾γߤޥ뤿  
 * ʬƱ٥γ׵֥å뤿ᡢ
 * 嵭γ׵٥꣱Ĺ⤤٥ꤹ롣
 */
#if ED_IPM == IPM_LEVEL0
#define if_ed_handler_intmask		IPM_LEVEL1
#elif ED_IPM == IPM_LEVEL1
#define if_ed_handler_intmask		IPM_LEVEL2
#endif 	/* ED_IPM == IPM_LEVEL0 */

/*
 *  TCP/IP ץȥ륹å̾Υ͡
 */

#if TKERNEL_PRVER < 0x1042u	/* JSP-1.4.2  */

#define ed_ena_inter	_tinet_ed_ena_inter

#endif	/* of #if TKERNEL_PRVER < 0x1042u */

#define ed_dis_inter	_tinet_ed_dis_inter
#define ed_bus_init	_tinet_ed_bus_init
#define ed_inter_init	_tinet_ed_inter_init

#ifndef _MACRO_ONLY

#if TKERNEL_PRVER < 0x1042u	/* JSP-1.4.2  */

/*
 *  JSP-1.4.2 ǤϡIPM ǡ顼ȯʤ褦롣
 */

typedef UB	IPM;

#else	/* of #if TKERNEL_PRVER < 0x1042u */

#define ed_ena_inter(ipm)	chg_ipm(ipm)

#endif	/* of #if TKERNEL_PRVER < 0x1042u */

/*
 *  ؿ
 */

#if TKERNEL_PRVER < 0x1042u	/* JSP-1.4.2  */

extern void ed_ena_inter (IPM ipm);

#endif	/* of #if TKERNEL_PRVER < 0x1042u */

extern IPM ed_dis_inter (void);
extern void ed_bus_init (void);
extern void ed_inter_init (void);

#endif	/* of #ifndef _MACRO_ONLY */

#endif /* _TINET_SYS_CONFIG_H_ */
